import 'package:flutter/material.dart';
import 'dart:async';
import 'package:webview_flutter/webview_flutter.dart';
import 'package:icash/pkgs/ReqModel.dart';
import 'package:icash/pkgs/ResModel.dart';
import 'package:icash/pkgs/actions.dart';
import 'package:icash/pkgs/callbackIcash.dart';

class WebPay extends StatefulWidget {
  CallBackIcash _callBackIcash;
  ReqModel _reqModel;
  WebPay(this._callBackIcash, this._reqModel);
  @override
  _WebPay createState() => _WebPay(this._callBackIcash, this._reqModel);
}

class _WebPay extends State<WebPay> {
// class WebPay extends StatelessWidget {
  CallBackIcash _callBackIcash;
  ReqModel _reqModel;
  final ResModel _resModel = ResModel();
  late BuildContext context;

  final Completer<WebViewController> _controller =
      Completer<WebViewController>();
  bool flag = false;
  _WebPay(this._callBackIcash, this._reqModel);

  @override
  void dispose() {
    if (!flag) {
      _resModel.status = ICactions.APP_CLOSED;
      _callBackIcash.onResult(_resModel, ICactions.APP_CLOSED);
    }
    super.dispose();
  }

  // @override
  // void initState() {
  //   super.initState();
  // }

  @override
  Widget build(BuildContext context) {
    this.context = context;
    return Scaffold(
        appBar: AppBar(
          title: Text("iCash Payment"),
        ),
        body: WebView(
            initialUrl: ResModel.URL + _reqModel.process_id,
            // initialUrl: "https://bit.ly/3DMtbNR",
            javascriptMode: JavascriptMode.unrestricted,
            onWebViewCreated: (WebViewController webViewController) {
              _controller.complete(webViewController);
            },
            navigationDelegate: (NavigationRequest request) {
              if (request.url.contains("https://play.google.com")) {
                // _resModel.status = ICactions.TRANSACTION_ERROR;
                // _sendDataBack();
                return NavigationDecision.prevent;
              } else if (request.url.contains(ReqModel.SUCCESS_URL)) {
                _resModel.fromUri(request.url);
                _sendDataBack();
                return NavigationDecision.prevent;
              } else if (request.url.contains(ReqModel.FAILED_URL)) {
                _resModel.status = ICactions.TRANSACTION_ERROR;
                _sendDataBack();
                return NavigationDecision.prevent;
              }
              return NavigationDecision.navigate;
            }));
  }

  void _sendDataBack() {
    flag = true;
    String _action = _resModel.status;
    if (_resModel.status == ICactions.SUCCESS) {
      _action = ICactions.SUCCESS;
    }
    _callBackIcash.onResult(_resModel, _action);
    Navigator.pop(context);
  }
}
