import 'package:flutter/material.dart';
import 'package:icash/pkgs/ApiContract.dart';
import 'package:icash/pkgs/ApiHelper.dart';
import 'package:icash/pkgs/Loading.dart';
import 'package:icash/pkgs/ResModel.dart';
import 'package:icash/pkgs/ReqModel.dart';
import 'package:icash/pkgs/WebPay.dart';
import 'package:icash/pkgs/actions.dart';
import 'package:icash/pkgs/callbackIcash.dart';
import 'package:icash/pkgs/icashInterface.dart';

class iCashPayment implements CallBackIcash, ApiContract {
  late BuildContext _buildContext;
  IcashInterface _icash;

  iCashPayment(this._icash);

  void doPayment(BuildContext _cnx,
      {vendor_key, title, description, amount, transaction_id}) async {
    _buildContext = _cnx;
    Navigator.push(
        _buildContext, MaterialPageRoute(builder: (context) => Loading()));
    Map<String, String> postValue = new Map<String, String>();
    postValue["vendor_key"] = vendor_key.toString();
    postValue["title"] = vendor_key.toString();
    postValue["description"] = description.toString();
    postValue["amount"] = amount.toString();
    postValue["transaction_id"] = transaction_id.toString();
    postValue["response_url"] = ReqModel.SUCCESS_URL;
    postValue["cancellation_url"] = ReqModel.FAILED_URL;
    ApiHelper _apiHelper = ApiHelper(this);
    _apiHelper.processRequest(body: postValue);
  }

  @override
  void onResult(ResModel resModel, String _action) {
    if (_action == ICactions.SUCCESS) {
      _icash.onIcashSuccess(resModel.toMap());
    } else {
      _icash.onIcashError(_action);
    }
  }

  @override
  void onApiResult(ReqModel reqModel) {
    if (reqModel.status == ICactions.SUCCESS) {
      Navigator.pushReplacement(_buildContext,
          MaterialPageRoute(builder: (context) => WebPay(this, reqModel)));
    } else {
      Navigator.pop(_buildContext);
      _icash.onIcashError(reqModel.status);
    }
  }
}
